/* 	$Id: grouptest.c,v 1.4 1994/03/30 22:56:52 gropp Exp $	 */

#ifndef lint
static char vcid[] = "$Id: grouptest.c,v 1.4 1994/03/30 22:56:52 gropp Exp $";
#endif /* lint */
#include "mpi.h"
#define MPI_Comm MPI_Comm

/*
    grouptest -
*/
int main( argc, argv )
int argc;
char **argv;
{
    int rank, size, i;
    MPI_Group group1, group2, group3, groupall, groupunion, groupintersection, newgroup;
    MPI_Comm newcomm;
    int ranks1[100], ranks2[100], ranks3[100];
    int nranks1=0, nranks2=0, nranks3=0;
    int grouprank;

    MPI_Init( &argc, &argv );
    MPI_Comm_rank( MPI_COMM_WORLD, &rank );
    MPI_Comm_size( MPI_COMM_WORLD, &size );
    MPI_Comm_group( MPI_COMM_WORLD, &groupall );

    printf( "%d: Process is alive ( %d total )\n", rank, size );

    /* Divide groups */
    for (i=0; i<size; i++) 
      if ( (i%3)==0 )
	ranks1[nranks1++] = i;
      else if ( (i%3)==1 )
	ranks2[nranks2++] = i;
      else
	ranks3[nranks3++] = i;

    MPI_Group_incl ( groupall, nranks1, ranks1, &group1 );
    MPI_Group_incl ( groupall, nranks2, ranks2, &group2 );
    MPI_Group_incl ( groupall, nranks3, ranks3, &group3 );

    MPI_Group_difference ( groupall, group2, &groupunion );
    printf ("The difference of group1 and group 2");

    MPIR_Dump_group ( groupall );
    MPIR_Dump_group ( group2 );
    MPIR_Dump_group ( groupunion );

    MPI_Comm_make ( MPI_COMM_WORLD, group3, &newcomm );
    MPI_Comm_group ( newcomm, &newgroup );

    
    MPI_Finalize();
    printf( "%d: Process exiting\n", rank );
}


