C/*
C *  
C *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
C *      All rights reserved.  See COPYRIGHT in top-level directory.
C */
C
C/* user include file for MPI programs, with no dependencies */
C
C/* assorted defined constants */
C
C/* return codes */
       integer MPI_SUCCESS,MPI_ERR_EXHAUSTED,MPI_ERR_TAG, 
     $ MPI_ERR_COMM_NULL,MPI_ERR_COMM_INTER,MPI_ERR_COMM_INTRA, 
     $ MPI_ERR_ARG,MPI_ERR_BUFFER,MPI_ERR_COUNT,MPI_ERR_TYPE, 
     $ MPI_ERR_ROOT,MPI_ERR_OP,MPI_ERR_ERRORCODE,
     $ MPI_ERR_GROUP,MPI_ERR_RANK,MPI_ERR_TOPOLOGY,
     $ MPI_ERR_DIMS,MPI_ERR_NULL,MPI_ERR_UNKNOWN,
     $ MPI_ERR_REQUEST,MPI_ERR_LIMIT,MPI_ERR_INTERN,
     $ MPI_ERR_NOMATCH,MPI_ERR_TRUNCATE,MPI_ERR_BAD_ARGS,
     $ MPI_ERR_INIT,MPI_ERR_PERM_KEY,MPI_ERR_BUFFER_EXISTS,
     $ MPI_ERR_COMM,MPI_ERR_OTHER,MPI_ERR_LASTCODE
       parameter (MPI_SUCCESS=0,MPI_ERR_EXHAUSTED=1,MPI_ERR_TAG=2, 
     $ MPI_ERR_COMM_NULL=3,MPI_ERR_COMM_INTER=4,MPI_ERR_COMM_INTRA=5, 
     $ MPI_ERR_ARG=6,MPI_ERR_BUFFER=7,MPI_ERR_COUNT=8,MPI_ERR_TYPE=9, 
     $ MPI_ERR_ROOT=10,MPI_ERR_OP=11,MPI_ERR_ERRORCODE=12,
     $ MPI_ERR_GROUP=13,MPI_ERR_RANK=14,MPI_ERR_TOPOLOGY=15,
     $ MPI_ERR_DIMS=16,MPI_ERR_NULL=17,MPI_ERR_UNKNOWN=18,
     $ MPI_ERR_REQUEST=19,MPI_ERR_LIMIT=20,MPI_ERR_INTERN=21,
     $ MPI_ERR_NOMATCH=22,MPI_ERR_TRUNCATE=23,MPI_ERR_BAD_ARGS=24,
     $ MPI_ERR_INIT=25,MPI_ERR_PERM_KEY=26,MPI_ERR_BUFFER_EXISTS=27,
     $ MPI_ERR_COMM=28,MPI_ERR_OTHER=29,MPI_ERR_LASTCODE=30)
C
       integer MPI_UNDEFINED
       parameter (MPI_UNDEFINED = (-32766))
C
C       
C/* Topology types */
CMPI_GRAPH=0,
CMPI_CART=1,
C
       integer  MPI_BOTTOM, MPI_PROC_NULL
       parameter ( MPI_BOTTOM = 0, MPI_PROC_NULL = (-2) )
C
      INTEGER MPI_SOURCE, MPI_TAG
      PARAMETER(MPI_SOURCE=2, MPI_TAG=3)
      INTEGER MPI_STATUS_SIZE
      PARAMETER (MPI_STATUS_SIZE=4)
      INTEGER MPI_MAX_PROCESSOR_NAME, MPI_MAX_ERROR_STRING
      PARAMETER (MPI_MAX_PROCESSOR_NAME=256,
     $           MPI_MAX_ERROR_STRING=256)
C     
C     We handle datatypes by putting the variables that hold them into
C     common.  This way, a Fortran program can directly use the various
C     datatypes and can even give them to C programs.
C
      integer MPI_INTEGER, MPI_REAL, MPI_DOUBLE_PRECISION, MPI_COMPLEX,
     $        MPI_LOGICAL, MPI_CHARACTER, MPI_BYTE, 
     $        MPI_DOUBLE_COMPLEX
      integer MPI_COMM_WORLD, MPI_COMM_SELF, MPI_GROUP_EMPTY
      integer MPI_SUM, MPI_MAX, MPI_MIN, MPI_PROD, MPI_LAND, MPI_BAND,
     $     MPI_LOR, MPI_BOR, MPI_LXOR, MPI_BXOR
      common /mpipriv/ MPI_INTEGER, MPI_REAL, MPI_DOUBLE_PRECISION,
     $     MPI_COMPLEX, MPI_DOUBLE_COMPLEX, 
     $     MPI_LOGICAL, MPI_CHARACTER, MPI_BYTE,
     $     MPI_COMM_WORLD, MPI_COMM_SELF, MPI_GROUP_EMPTY,
     $     MPI_SUM, MPI_MAX, MPI_MIN, MPI_PROD, MPI_LAND, MPI_BAND,
     $     MPI_LOR, MPI_BOR, MPI_LXOR, MPI_BXOR
C
      integer MPI_ANY_SOURCE
      parameter (MPI_ANY_SOURCE = (-1))
      integer MPI_ANY_TAG
      parameter (MPI_ANY_TAG = (-1))

