typedef void (*MPI_Op)();
typedef void (*MPI_U_Op)();

int MPI_Send(void*,int,MPI_Datatype,int,int,MPI_Comm);
int MPI_Recv(void*,int,MPI_Datatype,int,int,MPI_Comm,MPI_Status*);
int MPI_Rsend(void*,int,MPI_Datatype,int,int,MPI_Comm);
int MPI_Ssend(void*,int,MPI_Datatype,int,int,MPI_Comm);
int MPI_Isend(void*,int,MPI_Datatype,int,int,MPI_Comm,
		     MPI_Comm_request*);
int MPI_Irsend(void*,int,MPI_Datatype,int,int,MPI_Comm,
		      MPI_Comm_request*);
int MPI_Issend(void*,int,MPI_Datatype,int,int,MPI_Comm,
		      MPI_Comm_request*);
int MPI_Irecv(void*,int,MPI_Datatype,int,int,MPI_Comm,
		     MPI_Comm_request*);
int MPI_Wait(MPI_Comm_request*,MPI_Status*);
int MPI_Test(MPI_Comm_request,int*,MPI_Status*);
int MPI_Waitany(int,MPI_Comm_request*,int*,MPI_Status*);
int MPI_Testany(int,MPI_Comm_request*,int*,int*,MPI_Status*);
int MPI_Waitall(int,MPI_Comm_request*,MPI_Status*);
int MPI_Testall(int,MPI_Comm_request*,int*,MPI_Status*);
int MPI_Iprobe(int,int,MPI_Comm,int*,MPI_Status*);
int MPI_Probe(int,int,MPI_Comm,MPI_Status*);
int MPI_Cancel(MPI_Comm_request);
int MPI_Test_cancelled(MPI_Status,int*);
int MPI_Create_send(void*,int,MPI_Datatype,int,int,MPI_Comm,
			   MPI_Comm_request*);
int MPI_Create_rsend(void*,int,MPI_Datatype,int,int,MPI_Comm,
			    MPI_Comm_request*);
int MPI_Create_ssend(void*,int,MPI_Datatype,int,int,MPI_Comm,
			    MPI_Comm_request*);
int MPI_Create_recv(void*,int,MPI_Datatype,int,int,MPI_Comm,
			   MPI_Comm_request*);
int MPI_Start(MPI_Comm_request);
int MPI_Startall(int,MPI_Comm_request*);
int MPI_Request_free(MPI_Comm_request*);
int MPI_Sendrecv(void*,int,MPI_Datatype,int,int,
			void*,int,MPI_Datatype,int,int,MPI_Comm,MPI_Status*);
int MPI_Sendrecv_replace(void*,int,MPI_Datatype,int,int,
				int,int,MPI_Comm,MPI_Status*);
int MPI_Type_contiguous(int,MPI_Datatype,MPI_Datatype*);
int MPI_Type_vector(int,int,int,MPI_Datatype,MPI_Datatype*);
int MPI_Type_hvector(int,int,int,MPI_Datatype,MPI_Datatype*);
int MPI_Type_indexec(int,int*,int*,MPI_Datatype,MPI_Datatype*);
int MPI_Type_hindexec(int,int*,int*,MPI_Datatype,MPI_Datatype*);
int MPI_Type_struct(int,int*,int*,MPI_Datatype*,MPI_Datatype*);
int MPI_Address(void*,int*);
int MPI_Type_extent(MPI_Datatype,int*);
int MPI_Type_size(MPI_Datatype,int*);
int MPI_Type_count(MPI_Datatype,int*);
int MPI_Type_commit(MPI_Datatype*);
int MPI_Type_free(MPI_Datatype*);

/*MPI_Get_source*/
/*MPI_Get_count*/
/*MPI_Get_elements*/

int MPI_Barrier(MPI_Comm);
int MPI_Bcast(void*,int,MPI_Datatype,int,MPI_Comm);
int MPI_Gather(void*,int,MPI_Datatype,void*,int,MPI_Datatype,
		      int,MPI_Comm);
int MPI_Gatherv(void*,int,MPI_Datatype,void*,int*,int*,MPI_Datatype,
		       int,MPI_Comm);
int MPI_Scatter(void*,int,MPI_Datatype,void*,int,MPI_Datatype,
		       int,MPI_Comm);
int MPI_Scatterv(void*,int*,int*,MPI_Datatype,void*,int,MPI_Datatype,
			int,MPI_Comm);
int MPI_Allgather(void*,int,MPI_Datatype,void*,int,MPI_Datatype,
			 MPI_Comm);
int MPI_Allgatherv(void*,int,MPI_Datatype,void*,int*,int*,MPI_Datatype,
			  MPI_Comm);
int MPI_Alltoall(void*,int,MPI_Datatype,void*,int,MPI_Datatype,
			MPI_Comm);
int MPI_Alltoallv(void*,int*,int*,MPI_Datatype,
			 void*,int*,int*,MPI_Datatype,MPI_Comm);

int MPI_Reduce(void*,void*,int,MPI_Datatype,MPI_Op,int,MPI_Comm);
int MPI_User_reduce(void*,void*,int,MPI_Datatype,MPI_U_Op,int,MPI_Comm);
int MPI_User_reducea(void*,void*,int,MPI_Datatype,MPI_U_Op,int,MPI_Comm);
int MPI_Allreduce(void*,void*,int,MPI_Datatype,MPI_Op,MPI_Comm);
int MPI_User_allreduce(void*,void*,int,MPI_Datatype,MPI_U_Op,MPI_Comm);
int MPI_User_allreducea(void*,void*,int,MPI_Datatype,MPI_U_Op,MPI_Comm);
int MPI_Reduce_scatter(void*,void*,int*,MPI_Datatype,MPI_Op,MPI_Comm);
int MPI_Scan(void*,void*,int,MPI_Datatype,MPI_Op,MPI_Comm);
int MPI_User_scan(void*,void*,int,MPI_Datatype,MPI_U_Op,MPI_Comm);
int MPI_User_scana(void*,void*,int,MPI_Datatype,MPI_U_Op,MPI_Comm);

int MPI_Group_size(MPI_Group,int*);
int MPI_Group_rank(MPI_Group,int*);
int MPI_Group_translate_ranks(MPI_Group,int,int*,MPI_Group,int*);
int MPI_Group_union(MPI_Group,MPI_Group,MPI_Group*);
int MPI_Group_intersection(MPI_Group,MPI_Group,MPI_Group*);
int MPI_Group_difference(MPI_Group,MPI_Group,MPI_Group*);
int MPI_Group_incl(MPI_Group,int,int*,MPI_Group*);
int MPI_Group_excl(MPI_Group,int,int*,MPI_Group*);
int MPI_Group_range_incl(MPI_Group,int,int*,MPI_Group*);
int MPI_Group_range_excl(MPI_Group,int,int*,MPI_Group*);
int MPI_Group_free(MPI_Group*);
int MPI_Comm_size(MPI_Comm,int*);
int MPI_Comm_rank(MPI_Comm,int*);
int MPI_Comm_group(MPI_Comm,MPI_Group*);
int MPI_Comm_dup(MPI_Comm,MPI_Comm*);
int MPI_Comm_make(MPI_Comm,MPI_Group,MPI_Comm*);
int MPI_Comm_split(MPI_Comm,int,int,MPI_Comm*);
int MPI_Comm_free(MPI_Comm*);
int MPI_Comm_test_inter(MPI_Comm,int*);
int MPI_Intercomm_make(MPI_Comm,int,MPI_Comm,int,int,MPI_Comm *);
int MPI_Intercomm_merge(MPI_Comm,int,MPI_Comm *);

/*int MPI_Attr_create_key(MPI_Attr_copy_fn,MPI_Attr_del_fn,int*,void*);*/
int MPI_Attr_free_key(int);
int MPI_Put_Attr(MPI_Comm,int,void*);
int MPI_Get_Attr(MPI_Comm,int,void**,int*);

int MPI_Make_cart(MPI_Comm,int,int*,int*,int,MPI_Comm*);
int MPI_Make_dims(int,int,int*);
int MPI_Make_graph(MPI_Comm,int,int*,int*,int,MPI_Comm*);
int MPI_Topo_status(MPI_Comm,int*);
int MPI_Get_graphdims(MPI_Comm,int*,int*);
int MPI_Get_graph(MPI_Comm,int,int,int*,int*);
int MPI_Get_cartdim(MPI_Comm,int*);
int MPI_Get_cart(MPI_Comm,int,int*,int*,int*);
int MPI_Cart_rank(MPI_Comm,int*,int*);
int MPI_Cart_coords(MPI_Comm,int,int,int*);
int MPI_Graph_neighbors_count(MPI_Comm,int,int*);
int MPI_Graph_neighbors(MPI_Comm,int,int,int*);
int MPI_Cart_shift(MPI_Comm,int,int,int*,int*);
int MPI_Cart_sub(MPI_Comm,int*,MPI_Comm*);
int MPI_Map_cart(MPI_Comm,int,int*,int*,int*);
int MPI_Map_graph(MPI_Comm,int,int*,int*,int*);

int MPI_Get_valid_tag_range(int*,int*);
int MPI_Get_processor_name(int,char*);
int MPI_Get_host(MPI_Comm,int*);
int MPI_Get_buffer_params(int*,int*,int*,int*,int*,int*,int*,int*);
int MPI_Suggest_buffer_params(int,int,int,int,int,int,int,int,int*);
int MPI_User_specifies_buffer(MPI_Comm,void*,int);
/*int MPI_Get_error_mode(MPI_Comm,MPI_Errmode*);*/
/*int MPI_Set_error_mode(MPI_Comm,MPI_Errmode);*/
/*int MPI_Set_errhandler(MPI_Comm,MPI_Errorhandler);*/
int MPI_Error_string(int,int,char*);
int MPI_Init(int*,char**);
int MPI_Finalize();
int MPI_Initialized(int*);
int MPI_Abort(MPI_Comm,int);

int MPID_Get_count(int,MPI_Datatype,int*);
int MPID_Get_elements(int,MPI_Datatype,int*);
