/*
 *  $Id: chprobe.c,v 1.3 1994/04/12 15:58:17 gropp Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id";
#endif /* lint */

#include "mpid.h"

/*
   Implement probe by checking the unexpected receive queue.

 */
int MPID_NX_iprobe( tag, source, context_id, found, status )
int tag, source, context_id, *found;
MPI_Status *status;
{
MPID_RHANDLE *mpid_recv_handle;
MPIR_RHANDLE *dmpi_unexpected;

/* At this time, we check to see if the message has already been received */
DMPI_search_unexpected_queue( source, tag, context_id, 
			      found, 0, &dmpi_unexpected );
if (*found) {
    /* Copy relevant data to status */
    mpid_recv_handle           = &dmpi_unexpected->dev_rhandle;
    status->MPI_SOURCE	   = dmpi_unexpected->source;
    status->count	   = mpid_recv_handle->bytes_as_contig;
    status->count_in_bytes = mpid_recv_handle->bytes_as_contig;
    status->MPI_TAG	   = dmpi_unexpected->tag; 
    }
return MPI_SUCCESS;
}


int MPID_NX_probe( tag, source, context_id, status )
int tag, source, context_id;
MPI_Status *status;
{
int found;
while (1) {
    MPID_NX_iprobe( tag, source, context_id, &found, status );
    if (found) break;
    /* Wait for a message */
    MPID_NX_check_incoming( MPID_BLOCKING );
    }
}
