/*
 *  $Id: attr_getval.c,v 1.9 1994/04/07 08:55:54 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#ifndef lint
static char vcid[] = "$Id: attr_getval.c,v 1.9 1994/04/07 08:55:54 doss Exp $";
#endif /* lint */

#include <mpi.h>

#ifndef MPIR_TRUE
#define MPIR_TRUE   1
#define MPIR_FALSE  0
#endif

/*@C

MPI_Attr_get - retrieves attribute value by key

Input Parameters:
. comm - communicator to which attribute is attached (handle) 
. keyval - key value (integer) 

Output Parameters:
. attribute_val - attribute value, unless flag = false 
. flag -  true if an attribute value was extracted;  false if no attribute is associated with the key 

@*/
int MPI_Attr_get ( comm, keyval, attr_value, flag )
MPI_Comm comm;
int keyval;
void **attr_value;
int *flag;
{
  MPIR_HBT_node *attr;

  if (comm == MPI_COMM_NULL) {
    (*flag) = MPIR_FALSE;
    (*attr_value) = (void *)0;
  }
  else {
    MPIR_HBT_lookup(comm->attr_cache, keyval, &attr);
    if ( attr == (MPIR_HBT_node *)0 ) {
      (*flag) = MPIR_FALSE;
      (*attr_value) = (void *)0; 
    }
    else {
      (*flag) = MPIR_TRUE;
      (*attr_value) = attr->value;
    }
  }
  return(MPI_SUCCESS);
}



