/*
 *  $Id: comm_group.c,v 1.6 1994/04/07 08:55:54 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPI_Comm_group - Access the group associated with given communicator

@*/
int MPI_Comm_group ( comm, group )
MPI_Comm comm;
MPI_Group *group;
{
  if (comm == MPI_COMM_NULL) {
    (*group) = MPI_GROUP_NULL;
    return MPIR_ERROR( MPI_COMM_NULL, MPI_ERR_COMM, 
					  "Error in MPI_COMM_GROUP" );
  }
  else {
    MPIR_Group_dup( comm->local_group, group );
	return (MPI_SUCCESS);
  }
}
