/*
 *  $Id: comm_test_ic.c,v 1.5 1994/04/12 19:59:54 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPI_Comm_test_inter - Tests to see if a comm is an inter-communicator

Input Parameter:
. comm - communicator (handle) 
Output Parameter:
. flag - (logical) 

@*/
int MPI_Comm_test_inter ( comm, flag )
MPI_Comm  comm;
int      *flag;
{
  int errno = MPI_SUCCESS;

  /* Check for bad arguments */
  if (((comm == MPI_COMM_NULL) && (errno = MPI_ERR_COMM)) ||
	  ((flag == (int *)0)  && (errno = MPI_ERR_ARG))  )
	return MPIR_ERROR( comm, errno, "Error in MPI_COMM_TEST_INTER" );
  
  /* Set the flag */
  if (comm->comm_type == MPIR_INTER)
	(*flag) = 1; 
  else
	(*flag) = 0; 

  return (errno);
}
