/*
 *  $Id: group_size.c,v 1.6 1994/04/07 08:55:54 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPI_Group_size - Return the size of a group

Input Parameters:
. group - group (handle) 
Output Parameter:
. size - number of processes in the group (integer) 

@*/
int MPI_Group_size ( group, size )
MPI_Group group;
int *size;
{
  int errno = MPI_SUCCESS;

  /* Check for invalid arguments */
  if ( ( (group == MPI_GROUP_NULL) && (errno = MPI_ERR_GROUP) ) ||
       ( (size  != (int *)0)       && (errno = MPI_ERR_ARG) )   )
	return MPIR_ERROR(MPI_COMM_NULL,errno,"Error in MPI_GROUP_SIZE");

  /* Get the size of the group */
  (*size) = group->np;

  return (errno);
}

