/*
 *  $Id: bufattach.c,v 1.1 1994/03/29 21:45:18 gropp Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: bufattach.c,v 1.1 1994/03/29 21:45:18 gropp Exp $";
#endif /* lint */

#include "mpi.h"

/*@
  MPI_Buffer_attach - Attach a user-defined buffer for sending

Input Parameters:
. buffer - initial buffer address (choice) 
. size - buffer size, in bytes (integer) 

@*/
int MPI_Buffer_attach( buffer, size )
void *buffer;
int  size;
{
if (MPIR_Buffer_size > 0) 
    return MPIR_ERROR( (MPI_Comm)0, MPI_ERR_BUFFER_EXISTS, 
		       "Error in MPI_BUFFER_ATTACH" );
MPIR_Buffer_size = size;
MPIR_Buffer = buffer;

return MPI_SUCCESS;
}
