/*
 *  $Id: cancel.c,v 1.5 1994/03/29 22:07:40 gropp Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#ifndef lint
static char vcid[] = "$Id: cancel.c,v 1.5 1994/03/29 22:07:40 gropp Exp $";
#endif /* lint */

#include "mpi.h"
#include "mpisys.h"

/*@
    MPI_Cancel - Cancel a communication request

Input Parameter:
. request - communication request (handle) 

Note:
Cancel has not been implemented yet.
@*/
int MPI_Cancel( request )
MPI_Request *request;
{
    /* Note that cancel doesn't have to actually DO anything... */
    /* Needs an ADI hook to insure that there are no race conditions in
       the access of the device or queue structures */
    MPID_CANCEL( request );
    printf("cancel not yet implemented\n");
    return MPI_SUCCESS;
}

