/* datatypes.c */
/* Fortran interface file for sun4 */
#ifndef DEBUG_ALL
#define DEBUG_ALL
#endif
#include "mpi.h"
 void mpi_type_extent_( datatype, extent, __ierr )
MPI_Datatype datatype;
MPI_Aint     *extent;
int *__ierr;
{
*__ierr = MPI_Type_extent(
	(MPI_Datatype)*((int*)datatype),
	(MPI_Aint* )*((int*)extent));
}
 void mpi_type_contiguous_( count, oldtype, newtype, __ierr )
int          *count;
MPI_Datatype oldtype;
MPI_Datatype *newtype;
int *__ierr;
{
*__ierr = MPI_Type_Contiguous(*count,
	(MPI_Datatype)*((int*)oldtype),newtype);
}
 void mpi_type_vector_( count, oldtype, stride, blocklen, newtype, __ierr )
int          *count;
MPI_Datatype oldtype;
int       *stride;
int       *blocklen;
MPI_Datatype *newtype;
int *__ierr;
{
*__ierr = MPI_Type_Vector(*count,
	(MPI_Datatype)*((int*)oldtype),*stride,*blocklen,newtype);
}
 void mpi_type_hvector_( count, oldtype, stride, blocklen, newtype, __ierr )
int          *count;
MPI_Datatype oldtype;
MPI_Aint     *stride;
int       *blocklen;
MPI_Datatype *newtype;
int *__ierr;
{
*__ierr = MPI_Type_Hvector(*count,
	(MPI_Datatype)*((int*)oldtype),*stride,*blocklen,newtype);
}
 void mpi_type_indexed_( count, oldtype, indices, blocklens, newtype, __ierr )
int          *count;
MPI_Datatype oldtype;
int       indices[];
int       blocklens[];
MPI_Datatype *newtype;
int *__ierr;
{
*__ierr = MPI_Type_Indexed(*count,
	(MPI_Datatype)*((int*)oldtype),indices,blocklens,newtype);
}
 void mpi_type_hindexed_( count, array_of_blocklengths, array_of_displacements, 
        oldtype, newtype, __ierr )
int *count, *array_of_blocklengths;
MPI_Aint *array_of_displacements;
MPI_Datatype oldtype, *newtype;
int *__ierr;
{
*__ierr = MPI_Type_hindexed(*count,array_of_blocklengths,
	(MPI_Aint* )*((int*)array_of_displacements),
	(MPI_Datatype)*((int*)oldtype),newtype);
}
 void mpi_type_struct_( count, oldtypes, indices, blocklens, newtype, __ierr )
int          *count;
MPI_Datatype oldtypes[];
int       indices[];
int       blocklens[];
MPI_Datatype *newtype;
int *__ierr;
{
*__ierr = MPI_Type_Struct(*count,oldtypes,indices,blocklens,newtype);
}
