/*
 *  $Id
 *
 *  (C) 1994 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#ifndef lint
static char vcid[] = "$Id: initsend.c,v 1.2 1994/04/13 21:44:44 gropp Exp $";
#endif /* lint */

#include "mpi.h"
#include "mpisys.h"

/* This initializes the fields of a request structure */

int MPIR_Send_init( buf, count, datatype, dest, tag, comm, request, mode,
		    nonblocking )
void          *buf;
int           count;
MPI_Datatype  datatype;
int           dest;
int           tag;
MPI_Comm      comm;
MPI_Request   request;
int           mode;
int           nonblocking;
{
    request->type                 = MPIR_SEND;
    if (dest == MPI_PROC_NULL)
	request->shandle.dest     = dest;
    else
	request->shandle.dest     = comm->group->lrank_to_grank[dest];
    request->shandle.tag          = tag;
    request->shandle.contextid    = comm->send_context;
    request->shandle.lrank        = 
	comm->local_group->lrank_to_grank[comm->local_group->local_rank];
    request->shandle.mode         = mode;
    request->shandle.datatype     = datatype;
    request->shandle.bufadd       = buf;
    request->shandle.count        = count;
    request->shandle.completed    = NO;
    MPID_alloc_send_handle(&((request)->shandle.dev_shandle));
    MPID_set_send_is_nonblocking( &((request)->shandle.dev_shandle), 
				 nonblocking );
}
