/*
 *  $Id: topo_test.c,v 1.2 1994/04/12 20:12:58 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPI_Topo_test - Determine the type of topology (if any) associated with a 
                communicator

Input Parameter:
. comm - communicator (handle) 

Output Parameter:
. status - topology type of communicator  comm (choice) 

@*/
int MPI_Topo_test ( comm, status )
MPI_Comm  comm;
int      *status; 
{
  /* Check for valid arguments */
  if ( comm == MPI_COMM_NULL )
    return MPIR_ERROR( MPI_COMM_NULL, MPI_ERR_COMM, 
					  "Error in MPI_TOPO_TEST" );
  
  /* Set the status */
  if ( status != (int *)0 )
    (*status) = comm->topology.type;

  return (MPI_SUCCESS);
}
